function varargout = AnnotateOD(varargin)
% ANNOTATEOD M-file for AnnotateOD.fig
%      ANNOTATEOD, by itself, creates a new ANNOTATEOD or raises the existing
%      singleton*.
%
%      H = ANNOTATEOD returns the handle to a new ANNOTATEOD or the handle to
%      the existing singleton*.
%
%      ANNOTATEOD('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ANNOTATEOD.M with the given input arguments.
%
%      ANNOTATEOD('Property','Value',...) creates a new ANNOTATEOD or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before AnnotateOD_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to AnnotateOD_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help AnnotateOD

% Last Modified by GUIDE v2.5 08-Apr-2011 17:38:06

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @AnnotateOD_OpeningFcn, ...
                   'gui_OutputFcn',  @AnnotateOD_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before AnnotateOD is made visible.
function AnnotateOD_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to AnnotateOD (see VARARGIN)

% Choose default command line output for AnnotateOD
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes AnnotateOD wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = AnnotateOD_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% folder with images to process (initally the current directory)
handles.files.directory = pwd;
    
% number of image files to porcess
handles.files.nFiles = 0;
 
imageLogo=imread('eyeLogo.png');
axes(handles.mainFigure)
imshow(imageLogo); 

c='Optic Disc Ellipse Annotation Tool';
set(handles.display,'String',c);

%initiation 
handles.nameAnnotator=[];
handles.session=[];

% set all buttons as off except Open folder
set(handles.openFolderButton,'Enable','on');
set(handles.locateButton,'Enable','off');
set(handles.clearButton,'Enable','off');
set(handles.nextImageButton,'Enable','off');
set(handles.finish,'Enable','off');


% updates handles
guidata( hObject, handles )



function Name_Callback(hObject, eventdata, handles)
% hObject    handle to Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Name as text
%        str2double(get(hObject,'String')) returns contents of Name as a double

handles.nameAnnotator = get(hObject,'String');

guidata(hObject, handles);




% --- Executes during object creation, after setting all properties.
function Name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a
%        double

handles.session = str2num(get(hObject,'String'));

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% Get the date 
dateNtime = datestr(now, '  dd mm yyyy HH.MM AM ');
handles.dateNtime=dateNtime;
guidata(hObject, handles);


% --- Executes on button press in openFolderButton.
function openFolderButton_Callback(hObject, eventdata, handles)
% hObject    handle to openFolderButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    % if the user information is not fully inputted, exit
    if isempty(handles.nameAnnotator )||isempty(handles.session)
        return
    end
    
    % Set all buttons on 
    set(handles.locateButton,'Enable','on');
    set(handles.clearButton,'Enable','on');
    set(handles.nextImageButton,'Enable','on');
    set(handles.finish,'Enable','on');
    
    
    % Get folder
    directory = uigetdir( handles.files.directory );
    
    % If the user pressed cancelled, then exit
    if directory == 0 
        return
    end
    
    
    % Once open folder is pressed, save the annotator information 
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{'Name:'},'A1:A1');
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{handles.nameAnnotator},'B1:B1');
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{'Date:'},'A2:A2');
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{handles.dateNtime},'B2:B2');
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{'Image_name'},'A4:A4');
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{'X_Selected Points'},'B4:B4'); 
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{'Y_Selected Points'},'L4:L4'); 
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{'Ellipse Parameters'},'V4:V4');   
    xlswrite(strcat(directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{'Residual'},'AB4:AB4');
       
   
    % clear previous results
    handles.files = [];
   
    % populate selectFiles_listbox and save handles
    handles = openFilesFromDirectory( directory, handles );    
    handles.imageID=1;
    
    % open image
    handles.image = imread([ handles.files.directory filesep cell2mat(handles.files.name(handles.imageID)) ]);
    %handles.image = handles.image(:,:,2);    
 
    % updates handles
    guidata(hObject, handles);
    
    % plot image
    axes(handles.mainFigure)
    imshow(handles.image); hold on;
    
    %uiwait(msgbox('Please choose 10 points around OD border'));
     
c=strcat('Image:',num2str(handles.imageID),'/',num2str(handles.files.nFiles));
set(handles.display,'String',c);

% automatically get point without clicking annotateOD
locateButton_Callback(hObject, eventdata, handles);


    

% --- Executes on button press in locateButton.
function locateButton_Callback(hObject, eventdata, handles)
% hObject    handle to locateButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Mark selected image as non-located OD
handles.results(handles.imageID).Coefficient = 0;
handles.results(handles.imageID).Residual=0;
handles.results(handles.imageID).SelectedPoints=0;


% Obtain borders coordinate
for i=1:10
OD_borders(i,:) = ginput(1);
plot(OD_borders(i,1),OD_borders(i,2),'ko');
end
hold off;
    
% Fit Ellipse
a = fitellip(OD_borders);

% Residual of ellipse is calculated
ResSum=0;
for i=1:length(OD_borders)
    x=OD_borders(i,1);
    y=OD_borders(i,2);    
    residual=a(1)*x*x + a(2)*x*y + a(3)*y*y + a(4)*x + a(5)*y + a(6);
    ResSum=ResSum+residual;
end

handles.results(handles.imageID).Coefficient=a;
handles.results(handles.imageID).Residual=ResSum;
handles.results(handles.imageID).SelectedPoints=OD_borders;


% Draw Ellipse
drawellip(a,OD_borders,handles); 

guidata(hObject, handles);



% --- Executes on button press in clearButton.
function clearButton_Callback(hObject, eventdata, handles)
% hObject    handle to clearButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.results(handles.imageID).Coefficient=[];
handles.results(handles.imageID).Residual=[];
handles.results(handles.imageID).SelectedPoints=[];
axes(handles.mainFigure);
guidata(hObject, handles);
imshow(handles.image);hold on;



% --- Executes on button press in nextImageButton.
function nextImageButton_Callback(hObject, eventdata, handles)
% hObject    handle to nextImageButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% once next button is clicked, the information from previous image should be saved

%save name of image
    xlswrite(strcat(handles.files.directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{cell2mat(handles.files.name(handles.imageID))},...
        (strcat(strcat('A',num2str(handles.imageID+4)),':',strcat('A',num2str(handles.imageID+4)))));
    
    % save result of image
    resultInfo=[handles.results(handles.imageID).SelectedPoints(:,1)',handles.results(handles.imageID).SelectedPoints(:,2)',handles.results(handles.imageID).Coefficient',handles.results(handles.imageID).Residual];
    
    xlswrite(strcat(handles.files.directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),resultInfo,...
        (strcat(strcat('B',num2str(handles.imageID+4)),':',strcat('AB',num2str(handles.imageID+4)))));


% read the next image
handles.imageID=handles.imageID+1;
if handles.imageID > handles.files.nFiles
    c='All images have been annotated';
    set(handles.display,'String',c);
    return;
end

c=strcat('Image:',num2str(handles.imageID),'/',num2str(handles.files.nFiles));
set(handles.display,'String',c);

% open image
handles.image = imread([ handles.files.directory filesep cell2mat(handles.files.name(handles.imageID)) ]);   

% updates handles
guidata(hObject, handles);

% plot image
axes(handles.mainFigure)
imshow(handles.image);hold on;

% automatically get point without clicking annotateOD
locateButton_Callback(hObject, eventdata, handles);




% --- Executes on button press in finish.
function finish_Callback(hObject, eventdata, handles)
% hObject    handle to finish (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%save name of image
    xlswrite(strcat(handles.files.directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),{cell2mat(handles.files.name(handles.imageID))},...
        (strcat(strcat('A',num2str(handles.imageID+4)),':',strcat('A',num2str(handles.imageID+4)))));
    
    % save result of image
    resultInfo=[handles.results(handles.imageID).SelectedPoints(:,1)',handles.results(handles.imageID).SelectedPoints(:,2)',handles.results(handles.imageID).Coefficient',handles.results(handles.imageID).Residual];
    
    xlswrite(strcat(handles.files.directory,'\','GTOD','_',handles.nameAnnotator,'_',num2str(handles.session),'_',handles.dateNtime,'.','xlsx'),resultInfo,...
        (strcat(strcat('B',num2str(handles.imageID+4)),':',strcat('AB',num2str(handles.imageID+4)))));

    close;
