function varargout = SelectPoints(varargin)
% SELECTPOINTS M-file for SelectPoints.fig
%      SELECTPOINTS, by itself, creates a new SELECTPOINTS or raises the existing
%      singleton*.
%
%      H = SELECTPOINTS returns the handle to a new SELECTPOINTS or the handle to
%      the existing singleton*.
%
%      SELECTPOINTS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SELECTPOINTS.M with the given input arguments.
%
%      SELECTPOINTS('Property','Value',...) creates a new SELECTPOINTS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before SelectPoints_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to SelectPoints_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help SelectPoints

% Last Modified by GUIDE v2.5 08-Feb-2011 16:28:19

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @SelectPoints_OpeningFcn, ...
                   'gui_OutputFcn',  @SelectPoints_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before SelectPoints is made visible.
function SelectPoints_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to SelectPoints (see VARARGIN)

% Choose default command line output for SelectPoints
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


eyeLogo = imread('eyeLogo.png'); %Just show this logo on load.
imshow(eyeLogo);

setButtonStateFor_Start(handles);
% UIWAIT makes SelectPoints wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = SelectPoints_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in openButton.
function openButton_Callback(hObject, eventdata, handles)
% hObject    handle to openButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%set(handles.image_Axes(Jellyfish))

clear global points;
global currentImage;
global currentImageFilePath;
[filename, pathname] = uigetfile({'*.jpg';'*.png';'*.*'},'File Selector');
filePath = strcat(pathname,'/');
filePath = strcat(filePath,filename);
targetImage = imread(filePath);
currentImage = targetImage;
currentImageFilePath = filePath;
imshow(targetImage);

setButtonStateFor_Ready(handles);

% --- Executes on button press in zoomButton.
function zoomButton_Callback(hObject, eventdata, handles)
% hObject    handle to zoomButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

button_state = get(hObject,'Value');
if button_state == get(hObject,'Max')   % toggle button is pressed
   zoom on; 
elseif button_state == get(hObject,'Min')    % toggle button is not pressed
  disp('off');   
end


% --- Executes on button press in setPointButton.
function setPointButton_Callback(hObject, eventdata, handles)
% hObject    handle to setPointButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

setButtonStateFor_InProcess(handles);

getUserInput();

global points;

hold on;
plot(points(:,1), points(:,2), '.g');

setButtonStateFor_Ready(handles);


function getUserInput()

global points;
p = ginput(1);

points = [points; p];
disp(points);


% --- Executes on button press in FinishButton.
function FinishButton_Callback(hObject, eventdata, handles)
% hObject    handle to FinishButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%save data
global points;
global currentImageFilePath;

tempFilename = strcat(currentImageFilePath,'.mat');
disp(tempFilename);
save(tempFilename,'points');


close;


% --- Executes on button press in RemoveLastPointButton.
function RemoveLastPointButton_Callback(hObject, eventdata, handles)
% hObject    handle to RemoveLastPointButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global points;

points(end,:) = []; %remove last item.


%update the axis by re-plotting the values
global currentImage;
cla;
imshow(currentImage);
hold on;
plot(points(:,1), points(:,2), '.g');


function setButtonStateFor_Start(handles)

set(handles.openButton,'Enable','on');
set(handles.FinishButton,'Enable','on');
set(handles.zoomButton,'Enable','off');
set(handles.setPointButton,'Enable','off');
set(handles.RemoveLastPointButton,'Enable','off');


function setButtonStateFor_Ready(handles)

set(handles.openButton,'Enable','on');
set(handles.FinishButton,'Enable','on');
set(handles.zoomButton,'Enable','on');
set(handles.setPointButton,'Enable','on');
set(handles.RemoveLastPointButton,'Enable','on');

function setButtonStateFor_InProcess(handles)

set(handles.openButton,'Enable','off');
set(handles.FinishButton,'Enable','off');
set(handles.zoomButton,'Enable','off');
set(handles.setPointButton,'Enable','off');
set(handles.RemoveLastPointButton,'Enable','off');
