function handles = setODlocation( handles )
% locate the OD and its concentric circles by mouse clicking and save it
% into the results of the handle


% mark selected image as non-located OD
handles.results(handles.selectedImageID).ODradius = 0;

% show again
showImage( handles );

borders = ginput(2);

handles.results(handles.selectedImageID).ODcenter = mean(borders);
handles.results(handles.selectedImageID).ODradius = norm(borders(2,:) - borders(1,:)) / 2;

radius = num2str(round(10*handles.results(handles.selectedImageID).ODradius)/10);
stringText = ['OD radius is ', radius,' pixels'];

% update status text
set(handles.statusText, 'String', stringText);