function showImage ( handles )

    imID = handles.imageID;

    % open image
    if imID > 0
        
        % show on main axes
        axes(handles.mainFigure)
        
        % clear axes
        cla;       
        
        set(handles.mainFigure, 'NextPlot', 'ReplaceChildren')
        
        % copy the call back
        functionCall = @(hObject,eventdata)vampire('mainFigure_ButtonDownFcn',hObject,eventdata,guidata(hObject));
        

        % show image in handles
        if handles.showImBin && handles.imagesProcessed
            p = imshow(handles.results(imID).imBin); hold on;
        elseif handles.bwImageActivated
            p = imshow(handles.imageBW); hold on;
        else
            p = imshow(handles.image); hold on;
        end
        
        % set call back function (imshow rewrites it)
        set(p,'ButtonDownFcn', functionCall );

        % plot caption
        set(handles.imageName_text, 'String', [num2str(imID) ': ' cell2mat(handles.files.name(imID))] );
        
        % show located OD (if any)
        if handles.results(imID).ODradius > 0 && handles.showOD
            drawCircles ( handles, imID );
        end
        
    end   
    % make sure axis are showing only the image and not further
    xAxis = get(handles.mainFigure, 'XLim');
    yAxis = get(handles.mainFigure, 'YLim');
        
    left = max(xAxis(1), 0);
    right = min(xAxis(2), handles.imW);
    bottom = max(yAxis(1), 0);
    top = min(yAxis(2), handles.imH);
    
    axis([left right bottom top]);
%     axis([0 handles.imW 0 handles.imH])

    % save data
    guidata( handles.output, handles )